//---------------------------------------------------------------------------
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
// KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
// PURPOSE.
//
//                                                    Albert Lee 2003/12/09
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TZlib.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
volatile bool bStress = false;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	LARGE_INTEGER FreqCount;
	LARGE_INTEGER TC, TC1, TC2;
	double dTime;
	AnsiString asTime;

	TMemoryStream *TargetStream, *ResultStream;

	TZLibDecompressionStream *Decompress;
	TZLibCompressionStream *Compress;

	TargetStream = new TMemoryStream;

	TargetStream->LoadFromFile("raw.dat");

	if (TargetStream->Size == 0)
	{
		delete TargetStream;
		return;
	}
	ResultStream = new TMemoryStream;
	Compress = new TZLibCompressionStream;
	Decompress = new TZLibDecompressionStream;

	Label3->Caption = Compress->ZLibVersion();

	QueryPerformanceFrequency(&FreqCount);
	QueryPerformanceCounter(&TC1);

	Compress->Compress(TargetStream, ResultStream, 3);

	QueryPerformanceCounter(&TC2);

	TC.QuadPart = TC2.QuadPart - TC1.QuadPart;
	dTime = (double)(TC.QuadPart)/(FreqCount.QuadPart);
	asTime.sprintf("%f",dTime);
	Label1->Caption = asTime;

	ResultStream->SaveToFile("Ziped.dat");

	TargetStream->Clear();

	QueryPerformanceCounter(&TC1);
	Decompress->Decompress(ResultStream, TargetStream);
	QueryPerformanceCounter(&TC2);

	TC.QuadPart = TC2.QuadPart - TC1.QuadPart;
	dTime = (double)(TC.QuadPart)/(FreqCount.QuadPart);
	asTime.sprintf("%f",dTime);
	Label2->Caption = asTime;

	TargetStream->SaveToFile("UnZiped.dat");

	delete Decompress;
	delete Compress;
	delete TargetStream;
	delete ResultStream;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	TMemoryStream *TargetStream, *ResultStream;

	TZLibDecompressionStream *Decompress;
	TZLibCompressionStream *Compress;

	TargetStream = new TMemoryStream;

	TargetStream->LoadFromFile("raw.dat");

	if (TargetStream->Size == 0)
	{
		delete TargetStream;
		return;
	}

	ResultStream = new TMemoryStream;
	Compress = new TZLibCompressionStream;
	Decompress = new TZLibDecompressionStream;

	bStress = (bStress == false);
	if (bStress)
	{	Button2->Caption = "Stress Enable";		}
	else
	{	Button2->Caption = "Stress Disable";	}
	
	while (bStress)
	{
		Compress->Compress(TargetStream, ResultStream, 3);
		Decompress->Decompress(ResultStream, TargetStream);
	}

	delete Decompress;
	delete Compress;
	delete TargetStream;
	delete ResultStream;
}
//---------------------------------------------------------------------------

